// A Bison parser, made by GNU Bison 3.7.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 1 "parse/thrifty.yy"

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

/**
 * Thrift parser.
 *
 * This parser is used on a thrift definition file.
 *
 */

#define __STDC_LIMIT_MACROS
#define __STDC_FORMAT_MACROS
#include <cassert>
#include <stdio.h>
#include <inttypes.h>
#include <limits.h>
#include <stack>
#include <utility>

#include <boost/optional.hpp>

#include "thrift/compiler/ast/t_annotated.h"
#include "thrift/compiler/ast/t_scope.h"
#include "thrift/compiler/ast/base_types.h"

#include "thrift/compiler/parse/parsing_driver.h"

/**
 * Note macro expansion because this is different between OSS and internal
 * build, sigh.
 */
#include THRIFTY_HH

/**
 * Declare fbthrift_compiler_parse_lex() so we can use it.
 */
YY_DECL;
#define yylex fbthrift_compiler_parse_lex

namespace {

/**
 * This global variable is used for automatic numbering of field indices etc.
 * when parsing the members of a struct. Field values are automatically
 * assigned starting from -1 and working their way down.
 */
int y_field_val = -1;

/**
 * This global variable is used for automatic numbering of enum values.
 * y_enum_val is the last value assigned; the next auto-assigned value will be
 * y_enum_val+1, and then it continues working upwards.  Explicitly specified
 * enum values reset y_enum_val to that value.
 */
int32_t y_enum_val = -1;
int g_arglist = 0;
const int struct_is_struct = 0;
const int struct_is_union = 1;
const char* y_enum_name = nullptr;

// Define an enum class for all types that have lineno embedded.
enum class LineType {
  kTypedef,
  kEnum,
  kEnumValue,
  kConst,
  kStruct,
  kService,
  kFunction,
  kField,
  kXception,
  kAnnotationLastLineno,
};

// The LinenoStack class is used for keeping track of line number and automatic
// type checking
class LinenoStack {
 public:
  void push(LineType type, int lineno) {
    stack_.emplace(type, lineno);
  }
  int pop(LineType type) {
    if (type != stack_.top().first) {
      throw std::logic_error("Popping wrong type from line number stack");
    }
    int lineno = stack_.top().second;
    stack_.pop();
    return lineno;
  }
 private:
  std::stack<std::pair<LineType, int>> stack_;
};
LinenoStack lineno_stack;

} // namespace

namespace apache {
namespace thrift {
namespace compiler {

t_annotation* const_struct_to_annotation(
    parsing_driver& driver,
    std::unique_ptr<t_const_value> const_struct) {
  auto result = new t_annotation;
  result->object_val = std::make_shared<t_const>(
    driver.program,
    const_struct->get_ttype(),
    "",
    std::move(const_struct));
  result->object_val->set_lineno(driver.scanner->get_lineno());
  if (driver.mode == parsing_mode::PROGRAM) {
    driver.validate_const_type(result->object_val.get());
  }
  return result;
}

} // namespace compiler
} // namespace thrift
} // namespace apache


#line 180 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"


#include "thrifty.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif



// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 159 "parse/thrifty.yy"
namespace apache { namespace thrift { namespace compiler { namespace yy {
#line 259 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"

  /// Build a parser object.
  parser::parser (apache::thrift::compiler::parsing_driver& driver_yyarg, yyscan_t raw_scanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      raw_scanner (raw_scanner_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.YY_MOVE_OR_COPY< boost::optional<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
      case symbol_kind::S_StructHead: // StructHead
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_tok_st_identifier: // tok_st_identifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_TypeAnnotationValue: // TypeAnnotationValue
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.YY_MOVE_OR_COPY< t_annotated* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.YY_MOVE_OR_COPY< t_annotation* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Const: // Const
        value.YY_MOVE_OR_COPY< t_const* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.YY_MOVE_OR_COPY< t_const_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Definition: // Definition
        value.YY_MOVE_OR_COPY< t_doc* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Enum: // Enum
      case symbol_kind::S_EnumDefList: // EnumDefList
        value.YY_MOVE_OR_COPY< t_enum* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumDef: // EnumDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.YY_MOVE_OR_COPY< t_enum_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.YY_MOVE_OR_COPY< t_field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldRequiredness: // FieldRequiredness
        value.YY_MOVE_OR_COPY< t_field::e_req > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.YY_MOVE_OR_COPY< t_field_id > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Function: // Function
        value.YY_MOVE_OR_COPY< t_function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.YY_MOVE_OR_COPY< t_function_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Service: // Service
      case symbol_kind::S_Extends: // Extends
      case symbol_kind::S_Interaction: // Interaction
      case symbol_kind::S_FunctionList: // FunctionList
        value.YY_MOVE_OR_COPY< t_service* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.YY_MOVE_OR_COPY< t_sink* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.YY_MOVE_OR_COPY< t_stream_response* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Struct: // Struct
      case symbol_kind::S_Xception: // Xception
      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
      case symbol_kind::S_Throws: // Throws
      case symbol_kind::S_MaybeThrows: // MaybeThrows
      case symbol_kind::S_FieldList: // FieldList
        value.YY_MOVE_OR_COPY< t_struct* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeDefinition: // TypeDefinition
      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_FieldType: // FieldType
      case symbol_kind::S_BaseType: // BaseType
      case symbol_kind::S_SimpleBaseType: // SimpleBaseType
      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_SimpleContainerType: // SimpleContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.YY_MOVE_OR_COPY< t_type* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.YY_MOVE_OR_COPY< t_typedef* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.YY_MOVE_OR_COPY< t_typestructpair > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s)
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.move< boost::optional<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
      case symbol_kind::S_StructHead: // StructHead
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_tok_st_identifier: // tok_st_identifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_TypeAnnotationValue: // TypeAnnotationValue
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.move< t_annotated* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.move< t_annotation* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Const: // Const
        value.move< t_const* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.move< t_const_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Definition: // Definition
        value.move< t_doc* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Enum: // Enum
      case symbol_kind::S_EnumDefList: // EnumDefList
        value.move< t_enum* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumDef: // EnumDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.move< t_enum_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.move< t_field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldRequiredness: // FieldRequiredness
        value.move< t_field::e_req > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.move< t_field_id > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Function: // Function
        value.move< t_function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.move< t_function_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Service: // Service
      case symbol_kind::S_Extends: // Extends
      case symbol_kind::S_Interaction: // Interaction
      case symbol_kind::S_FunctionList: // FunctionList
        value.move< t_service* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.move< t_sink* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.move< t_stream_response* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Struct: // Struct
      case symbol_kind::S_Xception: // Xception
      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
      case symbol_kind::S_Throws: // Throws
      case symbol_kind::S_MaybeThrows: // MaybeThrows
      case symbol_kind::S_FieldList: // FieldList
        value.move< t_struct* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeDefinition: // TypeDefinition
      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_FieldType: // FieldType
      case symbol_kind::S_BaseType: // BaseType
      case symbol_kind::S_SimpleBaseType: // SimpleBaseType
      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_SimpleContainerType: // SimpleContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.move< t_type* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.move< t_typedef* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.move< t_typestructpair > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.copy< boost::optional<std::string> > (that.value);
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
      case symbol_kind::S_StructHead: // StructHead
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_tok_st_identifier: // tok_st_identifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_TypeAnnotationValue: // TypeAnnotationValue
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.copy< t_annotated* > (that.value);
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.copy< t_annotation* > (that.value);
        break;

      case symbol_kind::S_Const: // Const
        value.copy< t_const* > (that.value);
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.copy< t_const_value* > (that.value);
        break;

      case symbol_kind::S_Definition: // Definition
        value.copy< t_doc* > (that.value);
        break;

      case symbol_kind::S_Enum: // Enum
      case symbol_kind::S_EnumDefList: // EnumDefList
        value.copy< t_enum* > (that.value);
        break;

      case symbol_kind::S_EnumDef: // EnumDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.copy< t_enum_value* > (that.value);
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.copy< t_field* > (that.value);
        break;

      case symbol_kind::S_FieldRequiredness: // FieldRequiredness
        value.copy< t_field::e_req > (that.value);
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.copy< t_field_id > (that.value);
        break;

      case symbol_kind::S_Function: // Function
        value.copy< t_function* > (that.value);
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.copy< t_function_qualifier > (that.value);
        break;

      case symbol_kind::S_Service: // Service
      case symbol_kind::S_Extends: // Extends
      case symbol_kind::S_Interaction: // Interaction
      case symbol_kind::S_FunctionList: // FunctionList
        value.copy< t_service* > (that.value);
        break;

      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.copy< t_sink* > (that.value);
        break;

      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.copy< t_stream_response* > (that.value);
        break;

      case symbol_kind::S_Struct: // Struct
      case symbol_kind::S_Xception: // Xception
      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
      case symbol_kind::S_Throws: // Throws
      case symbol_kind::S_MaybeThrows: // MaybeThrows
      case symbol_kind::S_FieldList: // FieldList
        value.copy< t_struct* > (that.value);
        break;

      case symbol_kind::S_TypeDefinition: // TypeDefinition
      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_FieldType: // FieldType
      case symbol_kind::S_BaseType: // BaseType
      case symbol_kind::S_SimpleBaseType: // SimpleBaseType
      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_SimpleContainerType: // SimpleContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.copy< t_type* > (that.value);
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.copy< t_typedef* > (that.value);
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.copy< t_typestructpair > (that.value);
        break;

      default:
        break;
    }

    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.move< boost::optional<std::string> > (that.value);
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.move< double > (that.value);
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
      case symbol_kind::S_StructHead: // StructHead
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_tok_st_identifier: // tok_st_identifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_TypeAnnotationValue: // TypeAnnotationValue
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.move< t_annotated* > (that.value);
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.move< t_annotation* > (that.value);
        break;

      case symbol_kind::S_Const: // Const
        value.move< t_const* > (that.value);
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.move< t_const_value* > (that.value);
        break;

      case symbol_kind::S_Definition: // Definition
        value.move< t_doc* > (that.value);
        break;

      case symbol_kind::S_Enum: // Enum
      case symbol_kind::S_EnumDefList: // EnumDefList
        value.move< t_enum* > (that.value);
        break;

      case symbol_kind::S_EnumDef: // EnumDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.move< t_enum_value* > (that.value);
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.move< t_field* > (that.value);
        break;

      case symbol_kind::S_FieldRequiredness: // FieldRequiredness
        value.move< t_field::e_req > (that.value);
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.move< t_field_id > (that.value);
        break;

      case symbol_kind::S_Function: // Function
        value.move< t_function* > (that.value);
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.move< t_function_qualifier > (that.value);
        break;

      case symbol_kind::S_Service: // Service
      case symbol_kind::S_Extends: // Extends
      case symbol_kind::S_Interaction: // Interaction
      case symbol_kind::S_FunctionList: // FunctionList
        value.move< t_service* > (that.value);
        break;

      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.move< t_sink* > (that.value);
        break;

      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.move< t_stream_response* > (that.value);
        break;

      case symbol_kind::S_Struct: // Struct
      case symbol_kind::S_Xception: // Xception
      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
      case symbol_kind::S_Throws: // Throws
      case symbol_kind::S_MaybeThrows: // MaybeThrows
      case symbol_kind::S_FieldList: // FieldList
        value.move< t_struct* > (that.value);
        break;

      case symbol_kind::S_TypeDefinition: // TypeDefinition
      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_FieldType: // FieldType
      case symbol_kind::S_BaseType: // BaseType
      case symbol_kind::S_SimpleBaseType: // SimpleBaseType
      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_SimpleContainerType: // SimpleContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.move< t_type* > (that.value);
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.move< t_typedef* > (that.value);
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.move< t_typestructpair > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " (";
        YYUSE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, raw_scanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        yylhs.value.emplace< boost::optional<std::string> > ();
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
      case symbol_kind::S_StructHead: // StructHead
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_tok_st_identifier: // tok_st_identifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_TypeAnnotationValue: // TypeAnnotationValue
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        yylhs.value.emplace< t_annotated* > ();
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        yylhs.value.emplace< t_annotation* > ();
        break;

      case symbol_kind::S_Const: // Const
        yylhs.value.emplace< t_const* > ();
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        yylhs.value.emplace< t_const_value* > ();
        break;

      case symbol_kind::S_Definition: // Definition
        yylhs.value.emplace< t_doc* > ();
        break;

      case symbol_kind::S_Enum: // Enum
      case symbol_kind::S_EnumDefList: // EnumDefList
        yylhs.value.emplace< t_enum* > ();
        break;

      case symbol_kind::S_EnumDef: // EnumDef
      case symbol_kind::S_EnumValue: // EnumValue
        yylhs.value.emplace< t_enum_value* > ();
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        yylhs.value.emplace< t_field* > ();
        break;

      case symbol_kind::S_FieldRequiredness: // FieldRequiredness
        yylhs.value.emplace< t_field::e_req > ();
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        yylhs.value.emplace< t_field_id > ();
        break;

      case symbol_kind::S_Function: // Function
        yylhs.value.emplace< t_function* > ();
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        yylhs.value.emplace< t_function_qualifier > ();
        break;

      case symbol_kind::S_Service: // Service
      case symbol_kind::S_Extends: // Extends
      case symbol_kind::S_Interaction: // Interaction
      case symbol_kind::S_FunctionList: // FunctionList
        yylhs.value.emplace< t_service* > ();
        break;

      case symbol_kind::S_SinkReturnType: // SinkReturnType
        yylhs.value.emplace< t_sink* > ();
        break;

      case symbol_kind::S_StreamReturnType: // StreamReturnType
        yylhs.value.emplace< t_stream_response* > ();
        break;

      case symbol_kind::S_Struct: // Struct
      case symbol_kind::S_Xception: // Xception
      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
      case symbol_kind::S_Throws: // Throws
      case symbol_kind::S_MaybeThrows: // MaybeThrows
      case symbol_kind::S_FieldList: // FieldList
        yylhs.value.emplace< t_struct* > ();
        break;

      case symbol_kind::S_TypeDefinition: // TypeDefinition
      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_FieldType: // FieldType
      case symbol_kind::S_BaseType: // BaseType
      case symbol_kind::S_SimpleBaseType: // SimpleBaseType
      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_SimpleContainerType: // SimpleContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        yylhs.value.emplace< t_type* > ();
        break;

      case symbol_kind::S_Typedef: // Typedef
        yylhs.value.emplace< t_typedef* > ();
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        yylhs.value.emplace< t_typestructpair > ();
        break;

      default:
        break;
    }



      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // Program: HeaderList DefinitionList
#line 345 "parse/thrifty.yy"
    {
      driver.debug("Program -> Headers DefinitionList");
      /*
      TODO(dreiss): Decide whether full-program doctext is worth the trouble.
      if ($1) {
        driver.program->set_doc($1);
      }
      */
      driver.clear_doctext();
    }
#line 1351 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 3: // Identifier: tok_identifier
#line 358 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > ();
    }
#line 1359 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 4: // Identifier: tok_sink
#line 362 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "sink";
    }
#line 1367 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 5: // Identifier: tok_oneway
#line 366 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "oneway";
    }
#line 1375 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 6: // Identifier: tok_readonly
#line 370 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "readonly";
    }
#line 1383 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 7: // Identifier: tok_idempotent
#line 374 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "idempotent";
    }
#line 1391 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 8: // CaptureDocText: %empty
#line 379 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < boost::optional<std::string> > () = driver.doctext;
        driver.doctext = boost::none;
      } else {
        yylhs.value.as < boost::optional<std::string> > () = boost::none;
      }
    }
#line 1404 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 9: // DestroyDocText: %empty
#line 390 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.clear_doctext();
      }
    }
#line 1414 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 10: // HeaderList: HeaderList DestroyDocText Header
#line 400 "parse/thrifty.yy"
    {
      driver.debug("HeaderList -> HeaderList Header");
    }
#line 1422 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 11: // HeaderList: %empty
#line 404 "parse/thrifty.yy"
    {
      driver.debug("HeaderList -> ");
    }
#line 1430 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 12: // Header: Include
#line 410 "parse/thrifty.yy"
    {
      driver.debug("Header -> Include");
    }
#line 1438 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 13: // Header: tok_namespace Identifier Identifier
#line 414 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_namespace Identifier Identifier");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(yystack_[1].value.as < std::string > (), yystack_[0].value.as < std::string > ());
      }
    }
#line 1449 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 14: // Header: tok_namespace Identifier tok_literal
#line 421 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_namespace Identifier tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(yystack_[1].value.as < std::string > (), yystack_[0].value.as < std::string > ());
      }
    }
#line 1460 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 15: // Header: tok_cpp_include tok_literal
#line 428 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_cpp_include tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->add_cpp_include(yystack_[0].value.as < std::string > ());
      }
    }
#line 1471 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 16: // Header: tok_hs_include tok_literal
#line 435 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_hs_include tok_literal");
      // Do nothing. This syntax is handled by the hs compiler
    }
#line 1480 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 17: // Include: tok_include tok_literal
#line 442 "parse/thrifty.yy"
    {
      driver.debug("Include -> tok_include tok_literal");
      if (driver.mode == parsing_mode::INCLUDES) {
        std::string path = driver.include_file(std::string(yystack_[0].value.as < std::string > ()));
        if (!path.empty()) {
          if (driver.program_cache.find(path) == driver.program_cache.end()) {
            auto included_program = driver.program->add_include(path, std::string(yystack_[0].value.as < std::string > ()), driver.scanner->get_lineno());
            driver.program_cache[path] = included_program.get();
            driver.program_bundle->add_program(std::move(included_program));
          } else {
            auto include = std::make_unique<t_include>(driver.program_cache[path]);
            include->set_lineno(driver.scanner->get_lineno());
            driver.program->add_include(std::move(include));
          }
        }
      }
    }
#line 1502 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 18: // DefinitionList: DefinitionList CaptureDocText Definition
#line 462 "parse/thrifty.yy"
    {
      driver.debug("DefinitionList -> DefinitionList Definition");
      if (yystack_[1].value.as < boost::optional<std::string> > () && yystack_[0].value.as < t_doc* > ()) {
        yystack_[0].value.as < t_doc* > ()->set_doc(std::string{*yystack_[1].value.as < boost::optional<std::string> > ()});
      }
    }
#line 1513 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 19: // DefinitionList: %empty
#line 469 "parse/thrifty.yy"
    {
      driver.debug("DefinitionList -> ");
    }
#line 1521 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 20: // Definition: Const
#line 475 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Const");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->add_const(std::unique_ptr<t_const>(yystack_[0].value.as < t_const* > ()));
      } else {
        driver.delete_at_the_end(yystack_[0].value.as < t_const* > ());
      }
      yylhs.value.as < t_doc* > () = yystack_[0].value.as < t_const* > ();
    }
#line 1535 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 21: // Definition: TypeDefinition
#line 485 "parse/thrifty.yy"
    {
      driver.debug("Definition -> TypeDefinition");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.scope_cache->add_type(driver.program->get_name() + "." + yystack_[0].value.as < t_type* > ()->get_name(), yystack_[0].value.as < t_type* > ());
      }
      yylhs.value.as < t_doc* > () = yystack_[0].value.as < t_type* > ();
    }
#line 1547 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 22: // Definition: Service
#line 493 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Service");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.scope_cache->add_service(driver.program->get_name() + "." + yystack_[0].value.as < t_service* > ()->get_name(), yystack_[0].value.as < t_service* > ());
        driver.program->add_service(std::unique_ptr<t_service>(yystack_[0].value.as < t_service* > ()));
      } else {
        driver.delete_at_the_end(yystack_[0].value.as < t_service* > ());
      }
      yylhs.value.as < t_doc* > () = yystack_[0].value.as < t_service* > ();
    }
#line 1562 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 23: // Definition: Interaction
#line 504 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Interaction");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.scope_cache->add_interaction(driver.program->get_name() + "." + yystack_[0].value.as < t_service* > ()->get_name(), yystack_[0].value.as < t_service* > ());
        driver.program->add_interaction(std::unique_ptr<t_service>(yystack_[0].value.as < t_service* > ()));
      } else {
        driver.delete_at_the_end(yystack_[0].value.as < t_service* > ());
      }
      yylhs.value.as < t_doc* > () = yystack_[0].value.as < t_service* > ();
    }
#line 1577 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 24: // TypeDefinition: Typedef
#line 517 "parse/thrifty.yy"
    {
      driver.debug("TypeDefinition -> Typedef");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->add_typedef(std::unique_ptr<t_typedef>(yystack_[0].value.as < t_typedef* > ()));
      } else {
        driver.delete_at_the_end(yystack_[0].value.as < t_typedef* > ());
      }
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_typedef* > ();
    }
#line 1591 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 25: // TypeDefinition: Enum
#line 527 "parse/thrifty.yy"
    {
      driver.debug("TypeDefinition -> Enum");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->add_enum(std::unique_ptr<t_enum>(yystack_[0].value.as < t_enum* > ()));
      } else {
        driver.delete_at_the_end(yystack_[0].value.as < t_enum* > ());
      }
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_enum* > ();
    }
#line 1605 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 26: // TypeDefinition: Struct
#line 537 "parse/thrifty.yy"
    {
      driver.debug("TypeDefinition -> Struct");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->add_struct(std::unique_ptr<t_struct>(yystack_[0].value.as < t_struct* > ()));
      } else {
        driver.delete_at_the_end(yystack_[0].value.as < t_struct* > ());
      }
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_struct* > ();
    }
#line 1619 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 27: // TypeDefinition: Xception
#line 547 "parse/thrifty.yy"
    {
      driver.debug("TypeDefinition -> Xception");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->add_xception(std::unique_ptr<t_struct>(yystack_[0].value.as < t_struct* > ()));
      } else {
        driver.delete_at_the_end(yystack_[0].value.as < t_struct* > ());
      }
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_struct* > ();
    }
#line 1633 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 28: // $@1: %empty
#line 559 "parse/thrifty.yy"
    {
      lineno_stack.push(LineType::kTypedef, driver.scanner->get_lineno());
    }
#line 1641 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 29: // Typedef: StructuredAnnotations tok_typedef $@1 FieldType Identifier TypeAnnotations
#line 563 "parse/thrifty.yy"
    {
      driver.debug("TypeDef => StructuredAnnotations tok_typedef FieldType "
        "Identifier TypeAnnotations");
      t_typedef *td = new t_typedef(driver.program, yystack_[2].value.as < t_type* > (), yystack_[1].value.as < std::string > (), driver.scope_cache);
      yylhs.value.as < t_typedef* > () = td;
      yylhs.value.as < t_typedef* > ()->set_lineno(lineno_stack.pop(LineType::kTypedef));
      if (yystack_[0].value.as < t_annotated* > ()) {
        yylhs.value.as < t_typedef* > ()->annotations_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotations_);
        yylhs.value.as < t_typedef* > ()->annotation_objects_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotation_objects_);
        delete yystack_[0].value.as < t_annotated* > ();
      }
      if (yystack_[5].value.as < t_annotated* > ()) {
        yylhs.value.as < t_typedef* > ()->structured_annotations_ = std::move(yystack_[5].value.as < t_annotated* > ()->structured_annotations_);
        delete yystack_[5].value.as < t_annotated* > ();
      }
    }
#line 1662 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 30: // CommaOrSemicolon: ","
#line 582 "parse/thrifty.yy"
    {}
#line 1668 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 31: // CommaOrSemicolon: ";"
#line 584 "parse/thrifty.yy"
    {}
#line 1674 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 32: // CommaOrSemicolonOptional: CommaOrSemicolon
#line 588 "parse/thrifty.yy"
    {
      yylhs.value.as < bool > () = true;
    }
#line 1682 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 33: // CommaOrSemicolonOptional: %empty
#line 592 "parse/thrifty.yy"
    {
      yylhs.value.as < bool > () = false;
    }
#line 1690 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 34: // $@2: %empty
#line 598 "parse/thrifty.yy"
    {
      lineno_stack.push(LineType::kEnum, driver.scanner->get_lineno());
    }
#line 1698 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 35: // $@3: %empty
#line 602 "parse/thrifty.yy"
    {
      assert(!y_enum_name);
      y_enum_name = yystack_[0].value.as < std::string > ().c_str();
    }
#line 1707 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 36: // Enum: StructuredAnnotations tok_enum $@2 Identifier $@3 "{" EnumDefList "}" TypeAnnotations
#line 607 "parse/thrifty.yy"
    {
      driver.debug("Enum => StructuredAnnotations tok_enum Identifier { EnumDefList } TypeAnnotations");
      yylhs.value.as < t_enum* > () = yystack_[2].value.as < t_enum* > ();
      yylhs.value.as < t_enum* > ()->set_name(yystack_[5].value.as < std::string > ());
      yylhs.value.as < t_enum* > ()->set_lineno(lineno_stack.pop(LineType::kEnum));
      if (yystack_[0].value.as < t_annotated* > ()) {
        yylhs.value.as < t_enum* > ()->annotations_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotations_);
        yylhs.value.as < t_enum* > ()->annotation_objects_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotation_objects_);
        delete yystack_[0].value.as < t_annotated* > ();
      }
      if (yystack_[8].value.as < t_annotated* > ()) {
        yylhs.value.as < t_enum* > ()->structured_annotations_ = std::move(yystack_[8].value.as < t_annotated* > ()->structured_annotations_);
        delete yystack_[8].value.as < t_annotated* > ();
      }
      y_enum_name = nullptr;
    }
#line 1728 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 37: // EnumDefList: EnumDefList EnumDef
#line 626 "parse/thrifty.yy"
    {
      driver.debug("EnumDefList -> EnumDefList EnumDef");
      yylhs.value.as < t_enum* > () = yystack_[1].value.as < t_enum* > ();

      if (driver.mode == parsing_mode::PROGRAM) {
        auto const_val = std::make_unique<t_const_value>(yystack_[0].value.as < t_enum_value* > ()->get_value());

        const_val->set_is_enum();
        const_val->set_enum(yylhs.value.as < t_enum* > ());
        const_val->set_enum_value(yystack_[0].value.as < t_enum_value* > ());

        auto tconst = std::make_unique<t_const>(
            driver.program, i32_type(), yystack_[0].value.as < t_enum_value* > ()->get_name(), std::move(const_val));

        assert(y_enum_name != nullptr);
        std::string type_prefix = std::string(y_enum_name) + ".";
        driver.scope_cache->add_constant(
            driver.program->get_name() + "." + yystack_[0].value.as < t_enum_value* > ()->get_name(), tconst.get());
        driver.scope_cache->add_constant(
            driver.program->get_name() + "." + type_prefix + yystack_[0].value.as < t_enum_value* > ()->get_name(), tconst.get());

        yylhs.value.as < t_enum* > ()->append(std::unique_ptr<t_enum_value>(yystack_[0].value.as < t_enum_value* > ()), std::move(tconst));
      } else {
        driver.delete_at_the_end(yystack_[0].value.as < t_enum_value* > ());
      }
    }
#line 1759 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 38: // EnumDefList: %empty
#line 653 "parse/thrifty.yy"
    {
      driver.debug("EnumDefList -> ");
      yylhs.value.as < t_enum* > () = new t_enum(driver.program);
      y_enum_val = -1;
    }
#line 1769 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 39: // EnumDef: CaptureDocText StructuredAnnotations EnumValue TypeAnnotations CommaOrSemicolonOptional
#line 661 "parse/thrifty.yy"
    {
      driver.debug("EnumDef => CaptureDocText StructuredAnnotations EnumValue "
        "TypeAnnotations CommaOrSemicolonOptional");
      yylhs.value.as < t_enum_value* > () = yystack_[2].value.as < t_enum_value* > ();
      if (yystack_[4].value.as < boost::optional<std::string> > ()) {
        yylhs.value.as < t_enum_value* > ()->set_doc(std::string{*yystack_[4].value.as < boost::optional<std::string> > ()});
      }
      if (yystack_[1].value.as < t_annotated* > ()) {
        yylhs.value.as < t_enum_value* > ()->annotations_ = std::move(yystack_[1].value.as < t_annotated* > ()->annotations_);
        yylhs.value.as < t_enum_value* > ()->annotation_objects_ = std::move(yystack_[1].value.as < t_annotated* > ()->annotation_objects_);
        delete yystack_[1].value.as < t_annotated* > ();
      }
      if (yystack_[3].value.as < t_annotated* > ()) {
        yylhs.value.as < t_enum_value* > ()->structured_annotations_ = std::move(yystack_[3].value.as < t_annotated* > ()->structured_annotations_);
        delete yystack_[3].value.as < t_annotated* > ();
      }
    }
#line 1791 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 40: // EnumValue: Identifier "=" tok_int_constant
#line 681 "parse/thrifty.yy"
    {
      driver.debug("EnumValue -> Identifier = tok_int_constant");
      if (yystack_[0].value.as < int64_t > () < 0 && !driver.params.allow_neg_enum_vals) {
        driver.warning(1, "Negative value supplied for enum %s.", yystack_[2].value.as < std::string > ().c_str());
      }
      if (yystack_[0].value.as < int64_t > () < INT32_MIN || yystack_[0].value.as < int64_t > () > INT32_MAX) {
        // Note: this used to be just a warning.  However, since thrift always
        // treats enums as i32 values, I'm changing it to a fatal error.
        // I doubt this will affect many people, but users who run into this
        // will have to update their thrift files to manually specify the
        // truncated i32 value that thrift has always been using anyway.
        driver.failure("64-bit value supplied for enum %s will be truncated.", yystack_[2].value.as < std::string > ().c_str());
      }
      y_enum_val = yystack_[0].value.as < int64_t > ();
      yylhs.value.as < t_enum_value* > () = new t_enum_value(yystack_[2].value.as < std::string > (), y_enum_val);
      yylhs.value.as < t_enum_value* > ()->set_lineno(driver.scanner->get_lineno());
    }
#line 1813 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 41: // EnumValue: Identifier
#line 700 "parse/thrifty.yy"
    {
      driver.debug("EnumValue -> Identifier");
      if (y_enum_val == INT32_MAX) {
        driver.failure("enum value overflow at enum %s", yystack_[0].value.as < std::string > ().c_str());
      }
      yylhs.value.as < t_enum_value* > () = new t_enum_value(yystack_[0].value.as < std::string > ());

      ++y_enum_val;
      yylhs.value.as < t_enum_value* > ()->set_value(y_enum_val);
      yylhs.value.as < t_enum_value* > ()->set_lineno(driver.scanner->get_lineno());
    }
#line 1829 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 42: // $@4: %empty
#line 714 "parse/thrifty.yy"
    {
      lineno_stack.push(LineType::kConst, driver.scanner->get_lineno());
    }
#line 1837 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 43: // Const: StructuredAnnotations tok_const $@4 FieldType Identifier "=" ConstValue TypeAnnotations CommaOrSemicolonOptional
#line 718 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotations Const => tok_const FieldType Identifier = ConstValue");
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_const* > () = new t_const(driver.program, yystack_[5].value.as < t_type* > (), yystack_[4].value.as < std::string > (), std::unique_ptr<t_const_value>(yystack_[2].value.as < t_const_value* > ()));
        yylhs.value.as < t_const* > ()->set_lineno(lineno_stack.pop(LineType::kConst));
        if (yystack_[1].value.as < t_annotated* > ()) {
          yylhs.value.as < t_const* > ()->annotations_ = yystack_[1].value.as < t_annotated* > ()->annotations_;
          yylhs.value.as < t_const* > ()->annotation_objects_ = yystack_[1].value.as < t_annotated* > ()->annotation_objects_;
          delete yystack_[1].value.as < t_annotated* > ();
        }
        if (yystack_[8].value.as < t_annotated* > ()) {
          yylhs.value.as < t_const* > ()->structured_annotations_ = yystack_[8].value.as < t_annotated* > ()->structured_annotations_;
          delete yystack_[8].value.as < t_annotated* > ();
        }
        driver.validate_const_type(yylhs.value.as < t_const* > ());
        driver.scope_cache->add_constant(driver.program->get_name() + "." + yystack_[4].value.as < std::string > (), yylhs.value.as < t_const* > ());
      } else {
        delete yystack_[8].value.as < t_annotated* > ();
        delete yystack_[2].value.as < t_const_value* > ();
        delete yystack_[1].value.as < t_annotated* > ();
        yylhs.value.as < t_const* > () = nullptr;
      }
    }
#line 1865 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 44: // ConstValue: tok_bool_constant
#line 744 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_int_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_bool(yystack_[0].value.as < int64_t > ());
    }
#line 1875 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 45: // ConstValue: tok_int_constant
#line 750 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_int_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_integer(yystack_[0].value.as < int64_t > ());
      if (driver.mode == parsing_mode::PROGRAM) {
        if (!driver.params.allow_64bit_consts && (yystack_[0].value.as < int64_t > () < INT32_MIN || yystack_[0].value.as < int64_t > () > INT32_MAX)) {
          driver.warning(1, "64-bit constant \"%" PRIi64 "\" may not work in all languages.", yystack_[0].value.as < int64_t > ());
        }
      }
    }
#line 1890 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 46: // ConstValue: tok_dub_constant
#line 761 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_dub_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_double(yystack_[0].value.as < double > ());
    }
#line 1900 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 47: // ConstValue: tok_literal
#line 767 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_literal");
      yylhs.value.as < t_const_value* > () = new t_const_value(yystack_[0].value.as < std::string > ());
    }
#line 1909 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 48: // ConstValue: Identifier
#line 772 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => Identifier");
      t_const* constant = driver.scope_cache->get_constant(yystack_[0].value.as < std::string > ());
      driver.validate_not_ambiguous_enum(yystack_[0].value.as < std::string > ());
      if (!constant) {
        auto name_with_program_name = driver.program->get_name() + "." + yystack_[0].value.as < std::string > ();
        constant = driver.scope_cache->get_constant(name_with_program_name);
        driver.validate_not_ambiguous_enum(name_with_program_name);
      }
      if (constant != nullptr) {
        // Copy const_value to perform isolated mutations
        t_const_value* const_value = constant->get_value();
        yylhs.value.as < t_const_value* > () = const_value->clone().release();

        // We only want to clone the value, while discarding all real type
        // information.
        yylhs.value.as < t_const_value* > ()->set_ttype(nullptr);
        yylhs.value.as < t_const_value* > ()->set_is_enum(false);
        yylhs.value.as < t_const_value* > ()->set_enum(nullptr);
        yylhs.value.as < t_const_value* > ()->set_enum_value(nullptr);
      } else {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning(1, "Constant strings should be quoted: %s", yystack_[0].value.as < std::string > ().c_str());
        }
        yylhs.value.as < t_const_value* > () = new t_const_value(yystack_[0].value.as < std::string > ());
      }
    }
#line 1941 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 49: // ConstValue: ConstList
#line 800 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstList");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 1950 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 50: // ConstValue: ConstMap
#line 805 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstMap");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 1959 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 51: // ConstValue: ConstStruct
#line 810 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstStruct");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 1968 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 52: // ConstList: "[" ConstListContents CommaOrSemicolonOptional "]"
#line 817 "parse/thrifty.yy"
    {
      driver.debug("ConstList => [ ConstListContents CommaOrSemicolonOptional ]");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
    }
#line 1977 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 53: // ConstList: "[" "]"
#line 822 "parse/thrifty.yy"
    {
      driver.debug("ConstList => [ ]");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_list();
    }
#line 1987 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 54: // ConstListContents: ConstListContents CommaOrSemicolon ConstValue
#line 830 "parse/thrifty.yy"
    {
      driver.debug("ConstListContents => ConstListContents CommaOrSemicolon ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_list(std::unique_ptr<t_const_value>(yystack_[0].value.as < t_const_value* > ()));
    }
#line 1997 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 55: // ConstListContents: ConstValue
#line 836 "parse/thrifty.yy"
    {
      driver.debug("ConstListContents => ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_list();
      yylhs.value.as < t_const_value* > ()->add_list(std::unique_ptr<t_const_value>(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2008 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 56: // ConstMap: "{" ConstMapContents CommaOrSemicolonOptional "}"
#line 845 "parse/thrifty.yy"
    {
      driver.debug("ConstMap => { ConstMapContents CommaOrSemicolonOptional }");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
    }
#line 2017 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 57: // ConstMap: "{" "}"
#line 851 "parse/thrifty.yy"
    {
      driver.debug("ConstMap => { }");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
    }
#line 2027 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 58: // ConstMapContents: ConstMapContents CommaOrSemicolon ConstValue ":" ConstValue
#line 859 "parse/thrifty.yy"
    {
      driver.debug("ConstMapContents => ConstMapContents CommaOrSemicolon ConstValue : ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[4].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_map(std::unique_ptr<t_const_value>(yystack_[2].value.as < t_const_value* > ()), std::unique_ptr<t_const_value>(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2037 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 59: // ConstMapContents: ConstValue ":" ConstValue
#line 865 "parse/thrifty.yy"
    {
      driver.debug("ConstMapContents => ConstValue : ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->add_map(std::unique_ptr<t_const_value>(yystack_[2].value.as < t_const_value* > ()), std::unique_ptr<t_const_value>(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2048 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 60: // ConstStruct: ConstStructType "{" ConstStructContents CommaOrSemicolonOptional "}"
#line 874 "parse/thrifty.yy"
    {
      driver.debug("ConstStruct => ConstStructType { ConstStructContents CommaOrSemicolonOptional }");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->set_ttype(yystack_[4].value.as < t_type* > ());
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.validate_const_rec(yylhs.value.as < t_const_value* > ()->get_ttype()->get_name(), yylhs.value.as < t_const_value* > ()->get_ttype(), yylhs.value.as < t_const_value* > ());
      }
    }
#line 2061 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 61: // ConstStruct: ConstStructType "{" "}"
#line 883 "parse/thrifty.yy"
    {
      driver.debug("ConstStruct => ConstStructType { }");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->set_ttype(yystack_[2].value.as < t_type* > ());
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.validate_const_rec(yylhs.value.as < t_const_value* > ()->get_ttype()->get_name(), yylhs.value.as < t_const_value* > ()->get_ttype(), yylhs.value.as < t_const_value* > ());
      }
    }
#line 2075 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 62: // ConstStructType: Identifier
#line 895 "parse/thrifty.yy"
    {
      driver.debug("ConstStructType -> Identifier");
      if (driver.mode == parsing_mode::INCLUDES) {
        // Ignore identifiers in include mode
        yylhs.value.as < t_type* > () = nullptr;
      } else {
        // Lookup the identifier in the current scope
        yylhs.value.as < t_type* > () = driver.scope_cache->get_type(yystack_[0].value.as < std::string > ());
        if (!yylhs.value.as < t_type* > ()) {
          yylhs.value.as < t_type* > () = driver.scope_cache->get_type(driver.program->get_name() + "." + yystack_[0].value.as < std::string > ());
        }
        if (!yylhs.value.as < t_type* > ()) {
          driver.failure("The type '%s' is not defined yet. Types must be "
            "defined before the usage in constant values.", yystack_[0].value.as < std::string > ().c_str());
        }
      }
    }
#line 2097 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 63: // ConstStructContents: ConstStructContents CommaOrSemicolon Identifier "=" ConstValue
#line 915 "parse/thrifty.yy"
    {
      driver.debug("ConstStructContents => ConstStructContents CommaOrSemicolon Identifier = ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[4].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as < std::string > ()), std::unique_ptr<t_const_value>(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2107 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 64: // ConstStructContents: Identifier "=" ConstValue
#line 921 "parse/thrifty.yy"
    {
      driver.debug("ConstStructContents => Identifier = ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as < std::string > ()), std::unique_ptr<t_const_value>(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2118 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 65: // StructHead: tok_struct
#line 930 "parse/thrifty.yy"
    {
      yylhs.value.as < int64_t > () = struct_is_struct;
    }
#line 2126 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 66: // StructHead: tok_union
#line 934 "parse/thrifty.yy"
    {
      yylhs.value.as < int64_t > () = struct_is_union;
    }
#line 2134 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 67: // $@5: %empty
#line 940 "parse/thrifty.yy"
    {
      lineno_stack.push(LineType::kStruct, driver.scanner->get_lineno());
    }
#line 2142 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 68: // Struct: StructuredAnnotations StructHead $@5 Identifier "{" FieldList "}" TypeAnnotations
#line 944 "parse/thrifty.yy"
    {
      driver.debug("Struct => StructuredAnnotations StructHead Identifier "
        "{ FieldList } TypeAnnotations");
      yylhs.value.as < t_struct* > () = yystack_[2].value.as < t_struct* > ();
      yylhs.value.as < t_struct* > ()->set_union(yystack_[6].value.as < int64_t > () == struct_is_union);
      yylhs.value.as < t_struct* > ()->set_name(yystack_[4].value.as < std::string > ());
      yylhs.value.as < t_struct* > ()->set_lineno(lineno_stack.pop(LineType::kStruct));
      if (yystack_[0].value.as < t_annotated* > ()) {
        yylhs.value.as < t_struct* > ()->annotations_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotations_);
        yylhs.value.as < t_struct* > ()->annotation_objects_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotation_objects_);
        yylhs.value.as < t_struct* > ()->annotation_last_lineno_ = yystack_[0].value.as < t_annotated* > ()->annotation_last_lineno_;
        delete yystack_[0].value.as < t_annotated* > ();
      }
      if (yystack_[7].value.as < t_annotated* > ()) {
        yylhs.value.as < t_struct* > ()->structured_annotations_ = std::move(yystack_[7].value.as < t_annotated* > ()->structured_annotations_);
        delete yystack_[7].value.as < t_annotated* > ();
      }
      y_field_val = -1;
    }
#line 2166 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 69: // $@6: %empty
#line 966 "parse/thrifty.yy"
    {
      lineno_stack.push(LineType::kXception, driver.scanner->get_lineno());
    }
#line 2174 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 70: // Xception: StructuredAnnotations tok_xception $@6 Identifier "{" FieldList "}" TypeAnnotations
#line 970 "parse/thrifty.yy"
    {
      driver.debug("Xception => StructuredAnnotations tok_xception "
        "Identifier { FieldList } TypeAnnotations");
      yylhs.value.as < t_struct* > () = yystack_[2].value.as < t_struct* > ();
      yylhs.value.as < t_struct* > ()->set_name(yystack_[4].value.as < std::string > ());
      yylhs.value.as < t_struct* > ()->set_xception(true);
      yylhs.value.as < t_struct* > ()->set_lineno(lineno_stack.pop(LineType::kXception));
      if (yystack_[0].value.as < t_annotated* > ()) {
        yylhs.value.as < t_struct* > ()->annotations_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotations_);
        yylhs.value.as < t_struct* > ()->annotation_objects_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotation_objects_);
        delete yystack_[0].value.as < t_annotated* > ();
      }
      if (yystack_[7].value.as < t_annotated* > ()) {
        yylhs.value.as < t_struct* > ()->structured_annotations_ = std::move(yystack_[7].value.as < t_annotated* > ()->structured_annotations_);
        delete yystack_[7].value.as < t_annotated* > ();
      }

      const char* annotations[] = {"message", "code"};
      for (auto& annotation: annotations) {
        if (driver.mode == parsing_mode::PROGRAM
            && yylhs.value.as < t_struct* > ()->has_field_named(annotation)
            && yylhs.value.as < t_struct* > ()->annotations_.find(annotation) != yylhs.value.as < t_struct* > ()->annotations_.end()
            && strcmp(annotation, yylhs.value.as < t_struct* > ()->annotations_.find(annotation)->second.c_str()) != 0) {
          driver.warning(1, "Some generators (e.g. PHP) will ignore annotation '%s' "
                         "as it is also used as field", annotation);
        }
      }

      // Check that value of "message" annotation is
      // - a valid member of struct
      // - of type STRING
      if (driver.mode == parsing_mode::PROGRAM
          && yylhs.value.as < t_struct* > ()->annotations_.find("message") != yylhs.value.as < t_struct* > ()->annotations_.end()) {
        const std::string v = yylhs.value.as < t_struct* > ()->annotations_.find("message")->second;

        if (!yylhs.value.as < t_struct* > ()->has_field_named(v.c_str())) {
          driver.failure("member specified as exception 'message' should be a valid"
                         " struct member, '%s' in '%s' is not", v.c_str(), yystack_[4].value.as < std::string > ().c_str());
        }

        auto field = yylhs.value.as < t_struct* > ()->get_field_named(v.c_str());
        if (!field->get_type()->is_string_or_binary()) {
          driver.failure("member specified as exception 'message' should be of type "
                         "STRING, '%s' in '%s' is not", v.c_str(), yystack_[4].value.as < std::string > ().c_str());
        }
      }

      y_field_val = -1;
    }
#line 2228 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 71: // $@7: %empty
#line 1022 "parse/thrifty.yy"
    {
      lineno_stack.push(LineType::kService, driver.scanner->get_lineno());
    }
#line 2236 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 72: // Service: StructuredAnnotations tok_service $@7 Identifier Extends "{" FlagArgs FunctionList UnflagArgs "}" FunctionAnnotations
#line 1026 "parse/thrifty.yy"
    {
      driver.debug("Service => StructuredAnnotations tok_service "
        "Identifier Extends { FlagArgs FunctionList UnflagArgs } "
        "FunctionAnnotations");
      yylhs.value.as < t_service* > () = yystack_[3].value.as < t_service* > ();
      yylhs.value.as < t_service* > ()->set_name(yystack_[7].value.as < std::string > ());
      yylhs.value.as < t_service* > ()->set_extends(yystack_[6].value.as < t_service* > ());
      yylhs.value.as < t_service* > ()->set_lineno(lineno_stack.pop(LineType::kService));
      if (yystack_[0].value.as < t_annotated* > ()) {
        yylhs.value.as < t_service* > ()->annotations_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotations_);
        yylhs.value.as < t_service* > ()->annotation_objects_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotation_objects_);
        delete yystack_[0].value.as < t_annotated* > ();
      }
      if (yystack_[10].value.as < t_annotated* > ()) {
        yylhs.value.as < t_service* > ()->structured_annotations_ = std::move(yystack_[10].value.as < t_annotated* > ()->structured_annotations_);
        delete yystack_[10].value.as < t_annotated* > ();
      }
    }
#line 2259 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 73: // FlagArgs: %empty
#line 1046 "parse/thrifty.yy"
    {
       g_arglist = 1;
    }
#line 2267 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 74: // UnflagArgs: %empty
#line 1051 "parse/thrifty.yy"
    {
       g_arglist = 0;
    }
#line 2275 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 75: // Extends: tok_extends Identifier
#line 1057 "parse/thrifty.yy"
    {
      driver.debug("Extends -> tok_extends Identifier");
      yylhs.value.as < t_service* > () = nullptr;
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_service* > () = driver.scope_cache->get_service(yystack_[0].value.as < std::string > ());
        if (!yylhs.value.as < t_service* > ()) {
          yylhs.value.as < t_service* > () = driver.scope_cache->get_service(driver.program->get_name() + "." + yystack_[0].value.as < std::string > ());
        }
        if (!yylhs.value.as < t_service* > ()) {
          driver.failure("Service \"%s\" has not been defined.", yystack_[0].value.as < std::string > ().c_str());
        }
      }
    }
#line 2293 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 76: // Extends: %empty
#line 1071 "parse/thrifty.yy"
    {
      yylhs.value.as < t_service* > () = nullptr;
    }
#line 2301 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 77: // $@8: %empty
#line 1077 "parse/thrifty.yy"
    {
      lineno_stack.push(LineType::kService, driver.scanner->get_lineno());
    }
#line 2309 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 78: // Interaction: tok_interaction $@8 Identifier "{" FlagArgs FunctionList UnflagArgs "}" TypeAnnotations
#line 1081 "parse/thrifty.yy"
    {
      driver.debug("Interaction -> tok_interaction Identifier { FunctionList }");
      yylhs.value.as < t_service* > () = yystack_[3].value.as < t_service* > ();
      yylhs.value.as < t_service* > ()->set_name(yystack_[6].value.as < std::string > ());
      yylhs.value.as < t_service* > ()->set_is_interaction();
      yylhs.value.as < t_service* > ()->set_lineno(lineno_stack.pop(LineType::kService));
      for (auto* func : yylhs.value.as < t_service* > ()->get_functions()) {
        func->set_is_interaction_member();
        if (func->annotations_.count("thread")) {
          driver.failure("Interaction methods cannot be individually annotated with "
            "thread='eb'. Use process_in_event_base on the interaction instead.");
        }
      }

      if (yystack_[0].value.as < t_annotated* > ()) {
        bool eb_or_serial = false;
        for (const auto& it : yystack_[0].value.as < t_annotated* > ()->annotations_) {
          if (it.first == "process_in_event_base") {
            for (auto* func : yylhs.value.as < t_service* > ()->get_functions()) {
              func->annotations_["thread"] = "eb";
            }
            if (std::exchange(eb_or_serial, true)) {
              driver.failure("EB interactions are already serial");
            }
          } else if (it.first == "serial") {
            yylhs.value.as < t_service* > ()->set_is_serial_interaction();
            if (std::exchange(eb_or_serial, true)) {
              driver.failure("EB interactions are already serial");
            }
          } else {
            driver.failure("Unknown interaction annotation '%s'", it.first.c_str());
          }
        }
      }
    }
#line 2349 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 79: // FunctionList: FunctionList Function
#line 1119 "parse/thrifty.yy"
    {
      driver.debug("FunctionList -> FunctionList Function");
      yylhs.value.as < t_service* > () = yystack_[1].value.as < t_service* > ();
      yystack_[1].value.as < t_service* > ()->add_function(std::unique_ptr<t_function>(yystack_[0].value.as < t_function* > ()));
    }
#line 2359 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 80: // FunctionList: %empty
#line 1125 "parse/thrifty.yy"
    {
      driver.debug("FunctionList -> ");
      yylhs.value.as < t_service* > () = new t_service(driver.program);
    }
#line 2368 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 81: // Function: CaptureDocText StructuredAnnotations FunctionQualifier FunctionType Identifier "(" ParamList ")" MaybeThrows FunctionAnnotations CommaOrSemicolonOptional
#line 1132 "parse/thrifty.yy"
    {
      driver.debug("Function => CaptureDocText StructuredAnnotations FunctionQualifier "
        "FunctionType Identifier ( ParamList ) MaybeThrows "
        "FunctionAnnotations CommaOrSemicolonOptional");
      yystack_[4].value.as < t_struct* > ()->set_name(std::string(yystack_[6].value.as < std::string > ()) + "_args");
      auto* rettype = yystack_[7].value.as < t_type* > ();
      auto* arglist = yystack_[4].value.as < t_struct* > ();
      t_struct* streamthrows = rettype && rettype->is_streamresponse() ? static_cast<t_stream_response*>(rettype)->get_throws_struct() : nullptr;
      t_function* func;
      if (rettype && rettype->is_sink()) {
        func = new t_function(
          static_cast<t_sink*>(rettype),
          yystack_[6].value.as < std::string > (),
          std::unique_ptr<t_struct>(arglist),
          std::unique_ptr<t_struct>(yystack_[2].value.as < t_struct* > ())
        );
      } else {
        func = new t_function(
          rettype,
          yystack_[6].value.as < std::string > (),
          std::unique_ptr<t_struct>(arglist),
          std::unique_ptr<t_struct>(yystack_[2].value.as < t_struct* > ()),
          std::unique_ptr<t_struct>(streamthrows),
          yystack_[8].value.as < t_function_qualifier > ()
        );
      }
      if (yystack_[1].value.as < t_annotated* > ()) {
        func->annotations_ = std::move(yystack_[1].value.as < t_annotated* > ()->annotations_);
        func->annotation_objects_ = std::move(yystack_[1].value.as < t_annotated* > ()->annotation_objects_);
        delete yystack_[1].value.as < t_annotated* > ();
      }
      if (yystack_[9].value.as < t_annotated* > ()) {
        func->structured_annotations_ = std::move(yystack_[9].value.as < t_annotated* > ()->structured_annotations_);
        delete yystack_[9].value.as < t_annotated* > ();
      }
      yylhs.value.as < t_function* > () = func;
      if (yystack_[10].value.as < boost::optional<std::string> > ()) {
        yylhs.value.as < t_function* > ()->set_doc(std::string{*yystack_[10].value.as < boost::optional<std::string> > ()});
      }
      yylhs.value.as < t_function* > ()->set_lineno(driver.scanner->get_lineno());
      y_field_val = -1;
    }
#line 2415 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 82: // Function: tok_performs FieldType ";"
#line 1175 "parse/thrifty.yy"
    {
      driver.debug("Function => tok_performs FieldType");
      yylhs.value.as < t_function* > () = new t_function(
        yystack_[1].value.as < t_type* > (),
        yystack_[1].value.as < t_type* > () ? "create" + yystack_[1].value.as < t_type* > ()->get_name() : "<interaction placeholder>",
        std::make_unique<t_struct>(driver.program)
      );
      yylhs.value.as < t_function* > ()->set_lineno(driver.scanner->get_lineno());
      yylhs.value.as < t_function* > ()->set_is_interaction_constructor();
    }
#line 2430 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 83: // ParamList: ParamList Param
#line 1188 "parse/thrifty.yy"
    {
      driver.debug("ParamList -> ParamList , Param");
      yylhs.value.as < t_struct* > () = yystack_[1].value.as < t_struct* > ();
      if (!(yylhs.value.as < t_struct* > ()->append(std::unique_ptr<t_field>(yystack_[0].value.as < t_field* > ())))) {
        driver.failure("Parameter identifier %d for \"%s\" has already been used",
                       yystack_[0].value.as < t_field* > ()->get_key(), yystack_[0].value.as < t_field* > ()->get_name().c_str());
      }
    }
#line 2443 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 84: // ParamList: EmptyParamList
#line 1197 "parse/thrifty.yy"
    {
      yylhs.value.as < t_struct* > () = yystack_[0].value.as < t_struct* > ();
    }
#line 2451 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 85: // EmptyParamList: %empty
#line 1202 "parse/thrifty.yy"
    {
      driver.debug("EmptyParamList -> nil");
      t_struct* paramlist = new t_struct(driver.program);
      paramlist->set_paramlist(true);
      yylhs.value.as < t_struct* > () = paramlist;
    }
#line 2462 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 86: // Param: Field
#line 1211 "parse/thrifty.yy"
    {
      driver.debug("Param -> Field");
      yylhs.value.as < t_field* > () = yystack_[0].value.as < t_field* > ();
    }
#line 2471 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 87: // FunctionQualifier: tok_oneway
#line 1218 "parse/thrifty.yy"
    {
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::Oneway;
    }
#line 2479 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 88: // FunctionQualifier: tok_idempotent
#line 1222 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("idempotent");
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::Idempotent;
    }
#line 2488 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 89: // FunctionQualifier: tok_readonly
#line 1227 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("readonly");
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::Readonly;
    }
#line 2497 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 90: // FunctionQualifier: %empty
#line 1232 "parse/thrifty.yy"
    {
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::None;
    }
#line 2505 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 91: // Throws: tok_throws "(" FieldList ")"
#line 1239 "parse/thrifty.yy"
    {
      driver.debug("Throws -> tok_throws ( FieldList )");
      yylhs.value.as < t_struct* > () = yystack_[1].value.as < t_struct* > ();
    }
#line 2514 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 92: // MaybeThrows: Throws
#line 1245 "parse/thrifty.yy"
                {
			yylhs.value.as < t_struct* > () = yystack_[0].value.as < t_struct* > ();
		}
#line 2522 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 93: // MaybeThrows: %empty
#line 1248 "parse/thrifty.yy"
    {
			yylhs.value.as < t_struct* > () = new t_struct(driver.program);
		}
#line 2530 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 94: // FieldList: FieldList Field
#line 1254 "parse/thrifty.yy"
    {
      driver.debug("FieldList -> FieldList , Field");
      yylhs.value.as < t_struct* > () = yystack_[1].value.as < t_struct* > ();
      if (!(yylhs.value.as < t_struct* > ()->append(std::unique_ptr<t_field>(yystack_[0].value.as < t_field* > ())))) {
        driver.failure("Field identifier %d for \"%s\" has already been used",
                       yystack_[0].value.as < t_field* > ()->get_key(), yystack_[0].value.as < t_field* > ()->get_name().c_str());
      }
    }
#line 2543 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 95: // FieldList: %empty
#line 1263 "parse/thrifty.yy"
    {
      driver.debug("FieldList -> ");
      yylhs.value.as < t_struct* > () = new t_struct(driver.program);
    }
#line 2552 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 96: // Field: CaptureDocText StructuredAnnotations FieldIdentifier FieldRequiredness FieldType Identifier FieldValue TypeAnnotations CommaOrSemicolonOptional
#line 1270 "parse/thrifty.yy"
    {
      driver.debug("Field => CaptureDocText FieldIdentifier FieldRequiredness "
        "FieldType Identifier FieldValue TypeAnnotations "
        "StructuredAnnotations CommaOrSemicolonOptional");
      if (yystack_[6].value.as < t_field_id > ().auto_assigned) {
        driver.warning(1, "No field key specified for %s, resulting protocol may have conflicts "
          "or not be backwards compatible!", yystack_[3].value.as < std::string > ().c_str());
        if (driver.params.strict >= 192) {
          driver.failure("Implicit field keys are deprecated and not allowed with -strict");
        }
      }

      yylhs.value.as < t_field* > () = new t_field(yystack_[4].value.as < t_type* > (), yystack_[3].value.as < std::string > (), yystack_[6].value.as < t_field_id > ().value);
      yylhs.value.as < t_field* > ()->set_req(yystack_[5].value.as < t_field::e_req > ());
      yylhs.value.as < t_field* > ()->set_lineno(lineno_stack.pop(LineType::kField));
      if (yystack_[2].value.as < t_const_value* > ()) {
        driver.validate_field_value(yylhs.value.as < t_field* > (), yystack_[2].value.as < t_const_value* > ());
        yylhs.value.as < t_field* > ()->set_value(std::unique_ptr<t_const_value>(yystack_[2].value.as < t_const_value* > ()));
      }
      if (yystack_[8].value.as < boost::optional<std::string> > ()) {
        yylhs.value.as < t_field* > ()->set_doc(std::string{*yystack_[8].value.as < boost::optional<std::string> > ()});
      }
      if (yystack_[1].value.as < t_annotated* > ()) {
        for (const auto& it : yystack_[1].value.as < t_annotated* > ()->annotations_) {
          if (it.first == "cpp.ref" || it.first == "cpp2.ref") {
            if (yystack_[5].value.as < t_field::e_req > () != t_field::T_OPTIONAL) {
              driver.warning(1, "`cpp.ref` field must be optional if it is recursive.");
            }
            break;
          }
        }
        yylhs.value.as < t_field* > ()->annotations_ = std::move(yystack_[1].value.as < t_annotated* > ()->annotations_);
        yylhs.value.as < t_field* > ()->annotation_objects_ = std::move(yystack_[1].value.as < t_annotated* > ()->annotation_objects_);
        delete yystack_[1].value.as < t_annotated* > ();
      }
      if (yystack_[7].value.as < t_annotated* > ()) {
        yylhs.value.as < t_field* > ()->structured_annotations_ = std::move(yystack_[7].value.as < t_annotated* > ()->structured_annotations_);
        delete yystack_[7].value.as < t_annotated* > ();
      }
    }
#line 2597 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 97: // FieldIdentifier: tok_int_constant ":"
#line 1313 "parse/thrifty.yy"
    {
      if (yystack_[1].value.as < int64_t > () <= 0) {
        if (driver.params.allow_neg_field_keys) {
          /*
           * allow_neg_field_keys exists to allow users to add explicitly
           * specified key values to old .thrift files without breaking
           * protocol compatibility.
           */
          if (yystack_[1].value.as < int64_t > () != y_field_val) {
            /*
             * warn if the user-specified negative value isn't what
             * thrift would have auto-assigned.
             */
            driver.warning(1, "Negative field key (%d) differs from what would be "
                           "auto-assigned by thrift (%d).", yystack_[1].value.as < int64_t > (), y_field_val);
          }
          /*
           * Leave $1 as-is, and update y_field_val to be one less than $1.
           * The FieldList parsing will catch any duplicate key values.
           */
          y_field_val = yystack_[1].value.as < int64_t > () - 1;
          yylhs.value.as < t_field_id > ().value = yystack_[1].value.as < int64_t > ();
          yylhs.value.as < t_field_id > ().auto_assigned = false;
        } else {
          driver.warning(1, "Nonpositive value (%d) not allowed as a field key.",
                         yystack_[1].value.as < int64_t > ());
          yylhs.value.as < t_field_id > ().value = y_field_val--;
          yylhs.value.as < t_field_id > ().auto_assigned = true;
        }
      } else {
        yylhs.value.as < t_field_id > ().value = yystack_[1].value.as < int64_t > ();
        yylhs.value.as < t_field_id > ().auto_assigned = false;
      }
      lineno_stack.push(LineType::kField, driver.scanner->get_lineno());
    }
#line 2637 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 98: // FieldIdentifier: %empty
#line 1349 "parse/thrifty.yy"
    {
      yylhs.value.as < t_field_id > ().value = y_field_val--;
      yylhs.value.as < t_field_id > ().auto_assigned = true;
      lineno_stack.push(LineType::kField, driver.scanner->get_lineno());
    }
#line 2647 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 99: // FieldRequiredness: tok_required
#line 1357 "parse/thrifty.yy"
    {
      if (g_arglist) {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning(1, "required keyword is ignored in argument lists.");
        }
        yylhs.value.as < t_field::e_req > () = t_field::T_OPT_IN_REQ_OUT;
      } else {
        yylhs.value.as < t_field::e_req > () = t_field::T_REQUIRED;
      }
    }
#line 2662 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 100: // FieldRequiredness: tok_optional
#line 1368 "parse/thrifty.yy"
    {
      if (g_arglist) {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning(1, "optional keyword is ignored in argument lists.");
        }
        yylhs.value.as < t_field::e_req > () = t_field::T_OPT_IN_REQ_OUT;
      } else {
        yylhs.value.as < t_field::e_req > () = t_field::T_OPTIONAL;
      }
    }
#line 2677 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 101: // FieldRequiredness: %empty
#line 1379 "parse/thrifty.yy"
    {
      yylhs.value.as < t_field::e_req > () = t_field::T_OPT_IN_REQ_OUT;
    }
#line 2685 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 102: // FieldValue: "=" ConstValue
#line 1385 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
      } else {
        delete yystack_[0].value.as < t_const_value* > ();
        yylhs.value.as < t_const_value* > () = nullptr;
      }
    }
#line 2698 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 103: // FieldValue: %empty
#line 1394 "parse/thrifty.yy"
    {
      yylhs.value.as < t_const_value* > () = nullptr;
    }
#line 2706 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 104: // FunctionType: ResponseAndStreamReturnType
#line 1400 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> ResponseAndStreamReturnType");
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_type* > ();
    }
#line 2715 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 105: // FunctionType: ResponseAndSinkReturnType
#line 1405 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> ResponseAndSinkReturnType");
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_type* > ();
    }
#line 2724 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 106: // FunctionType: FieldType
#line 1410 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> FieldType");
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_type* > ();
    }
#line 2733 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 107: // FunctionType: tok_void
#line 1415 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> tok_void");
      yylhs.value.as < t_type* > () = void_type();
    }
#line 2742 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 108: // ResponseAndStreamReturnType: FieldType "," StreamReturnType
#line 1422 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndStreamReturnType -> FieldType, StreamReturnType");
      yystack_[0].value.as < t_stream_response* > ()->set_first_response_type(yystack_[2].value.as < t_type* > ());
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_stream_response* > ();
    }
#line 2752 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 109: // ResponseAndStreamReturnType: StreamReturnType
#line 1428 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndStreamReturnType -> StreamReturnType");
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_stream_response* > ();
    }
#line 2761 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 110: // StreamReturnType: tok_stream "<" FieldType ">"
#line 1435 "parse/thrifty.yy"
  {
    driver.debug("StreamReturnType -> tok_stream < FieldType >");

    yylhs.value.as < t_stream_response* > () = new t_stream_response(yystack_[1].value.as < t_type* > ());

    if (driver.mode == parsing_mode::INCLUDES) {
      driver.delete_at_the_end(yylhs.value.as < t_stream_response* > ());
    } else {
      driver.program->add_unnamed_type(std::unique_ptr<t_type>{yylhs.value.as < t_stream_response* > ()});
    }
  }
#line 2777 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 111: // StreamReturnType: tok_stream "<" FieldType Throws ">"
#line 1447 "parse/thrifty.yy"
  {
    driver.debug("StreamReturnType -> tok_stream < FieldType Throws >");

    yylhs.value.as < t_stream_response* > () = new t_stream_response(yystack_[2].value.as < t_type* > (), yystack_[1].value.as < t_struct* > ());

    if (driver.mode == parsing_mode::INCLUDES) {
      driver.delete_at_the_end(yylhs.value.as < t_stream_response* > ());
    } else {
      driver.program->add_unnamed_type(std::unique_ptr<t_type>{yylhs.value.as < t_stream_response* > ()});
    }
  }
#line 2793 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 112: // ResponseAndSinkReturnType: FieldType "," SinkReturnType
#line 1461 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndSinkReturnType -> FieldType, SinkReturnType");
      yystack_[0].value.as < t_sink* > ()->set_first_response(yystack_[2].value.as < t_type* > ());
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_sink* > ();
    }
#line 2803 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 113: // ResponseAndSinkReturnType: SinkReturnType
#line 1467 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndSinkReturnType -> SinkReturnType");
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_sink* > ();
    }
#line 2812 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 114: // SinkReturnType: tok_sink "<" SinkFieldType "," SinkFieldType ">"
#line 1474 "parse/thrifty.yy"
    {
      driver.debug("SinkReturnType -> tok_sink<FieldType, FieldType>");
      yylhs.value.as < t_sink* > () = new t_sink(yystack_[3].value.as < t_typestructpair > ().first, yystack_[3].value.as < t_typestructpair > ().second, yystack_[1].value.as < t_typestructpair > ().first, yystack_[1].value.as < t_typestructpair > ().second);
      if (driver.mode == parsing_mode::INCLUDES) {
        driver.delete_at_the_end(yylhs.value.as < t_sink* > ());
      } else {
        driver.program->add_unnamed_type(std::unique_ptr<t_type>{yylhs.value.as < t_sink* > ()});
      }
    }
#line 2826 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 115: // SinkFieldType: FieldType
#line 1485 "parse/thrifty.yy"
    {
      yylhs.value.as < t_typestructpair > () = std::make_pair(yystack_[0].value.as < t_type* > (), nullptr);
    }
#line 2834 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 116: // SinkFieldType: FieldType Throws
#line 1489 "parse/thrifty.yy"
    {
      yylhs.value.as < t_typestructpair > () = std::make_pair(yystack_[1].value.as < t_type* > (), yystack_[0].value.as < t_struct* > ());
    }
#line 2842 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 117: // FieldType: Identifier TypeAnnotations
#line 1495 "parse/thrifty.yy"
    {
      driver.debug("FieldType => Identifier TypeAnnotations");
      if (driver.mode == parsing_mode::INCLUDES) {
        // Ignore identifiers in include mode
        yylhs.value.as < t_type* > () = nullptr;
        delete yystack_[0].value.as < t_annotated* > ();
      } else {
        // Lookup the identifier in the current scope
        yylhs.value.as < t_type* > () = driver.scope_cache->get_type(yystack_[1].value.as < std::string > ());
        if (!yylhs.value.as < t_type* > ()) {
          yylhs.value.as < t_type* > () = driver.scope_cache->get_type(driver.program->get_name() + "." + yystack_[1].value.as < std::string > ());
        }
        if (!yylhs.value.as < t_type* > ()) {
          yylhs.value.as < t_type* > () = driver.scope_cache->get_interaction(yystack_[1].value.as < std::string > ());
        }
        if (!yylhs.value.as < t_type* > ()) {
          yylhs.value.as < t_type* > () = driver.scope_cache->get_interaction(driver.program->get_name() + "." + yystack_[1].value.as < std::string > ());
        }
        // Create typedef in case we have annotations on the type.
        if (yylhs.value.as < t_type* > () && yystack_[0].value.as < t_annotated* > ()) {
          auto td = new t_typedef(
              const_cast<t_program*>(yylhs.value.as < t_type* > ()->get_program()), yylhs.value.as < t_type* > (), yylhs.value.as < t_type* > ()->get_name(), driver.scope_cache);
          td->annotations_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotations_);
          td->annotation_objects_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotation_objects_);
          delete yystack_[0].value.as < t_annotated* > ();
          yylhs.value.as < t_type* > () = td;
          driver.program->add_unnamed_typedef(std::unique_ptr<t_typedef>{td});
        }
        if (!yylhs.value.as < t_type* > ()) {
          /*
           * Either this type isn't yet declared, or it's never
             declared.  Either way allow it and we'll figure it out
             during generation.
           */
          auto td = new t_typedef(driver.program, yystack_[1].value.as < std::string > (), driver.scope_cache);
          yylhs.value.as < t_type* > () = td;
          driver.program->add_placeholder_typedef(std::unique_ptr<t_typedef>{td});
          if (yystack_[0].value.as < t_annotated* > ()) {
            yylhs.value.as < t_type* > ()->annotations_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotations_);
            yylhs.value.as < t_type* > ()->annotation_objects_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotation_objects_);
            delete yystack_[0].value.as < t_annotated* > ();
          }
        }
      }
    }
#line 2892 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 118: // FieldType: BaseType
#line 1541 "parse/thrifty.yy"
    {
      driver.debug("FieldType -> BaseType");
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_type* > ();
    }
#line 2901 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 119: // FieldType: ContainerType
#line 1546 "parse/thrifty.yy"
    {
      driver.debug("FieldType -> ContainerType");
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_type* > ();
      if (driver.mode == parsing_mode::INCLUDES) {
        driver.delete_at_the_end(yylhs.value.as < t_type* > ());
      } else {
        driver.program->add_unnamed_type(std::unique_ptr<t_type>{yylhs.value.as < t_type* > ()});
      }
    }
#line 2915 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 120: // BaseType: SimpleBaseType TypeAnnotations
#line 1557 "parse/thrifty.yy"
    {
      driver.debug("BaseType => SimpleBaseType TypeAnnotations");
      if (yystack_[0].value.as < t_annotated* > ()) {
        yylhs.value.as < t_type* > () = new t_base_type(*static_cast<t_base_type*>(yystack_[1].value.as < t_type* > ()));
        yylhs.value.as < t_type* > ()->annotations_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotations_);
        yylhs.value.as < t_type* > ()->annotation_objects_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotation_objects_);
        delete yystack_[0].value.as < t_annotated* > ();
        if (driver.mode == parsing_mode::INCLUDES) {
          driver.delete_at_the_end(yylhs.value.as < t_type* > ());
        } else {
          driver.program->add_unnamed_type(std::unique_ptr<t_type>{yylhs.value.as < t_type* > ()});
        }
      } else {
        yylhs.value.as < t_type* > () = yystack_[1].value.as < t_type* > ();
      }
    }
#line 2936 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 121: // SimpleBaseType: tok_string
#line 1576 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_string");
      yylhs.value.as < t_type* > () = string_type();
    }
#line 2945 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 122: // SimpleBaseType: tok_binary
#line 1581 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_binary");
      yylhs.value.as < t_type* > () = binary_type();
    }
#line 2954 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 123: // SimpleBaseType: tok_bool
#line 1586 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_bool");
      yylhs.value.as < t_type* > () = bool_type();
    }
#line 2963 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 124: // SimpleBaseType: tok_byte
#line 1591 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_byte");
      yylhs.value.as < t_type* > () = byte_type();
    }
#line 2972 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 125: // SimpleBaseType: tok_i16
#line 1596 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i16");
      yylhs.value.as < t_type* > () = i16_type();
    }
#line 2981 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 126: // SimpleBaseType: tok_i32
#line 1601 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i32");
      yylhs.value.as < t_type* > () = i32_type();
    }
#line 2990 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 127: // SimpleBaseType: tok_i64
#line 1606 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i64");
      yylhs.value.as < t_type* > () = i64_type();
    }
#line 2999 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 128: // SimpleBaseType: tok_double
#line 1611 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_double");
      yylhs.value.as < t_type* > () = double_type();
    }
#line 3008 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 129: // SimpleBaseType: tok_float
#line 1616 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_float");
      yylhs.value.as < t_type* > () = float_type();
    }
#line 3017 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 130: // ContainerType: SimpleContainerType TypeAnnotations
#line 1622 "parse/thrifty.yy"
    {
      driver.debug("ContainerType => SimpleContainerType TypeAnnotations");
      yylhs.value.as < t_type* > () = yystack_[1].value.as < t_type* > ();
      if (yystack_[0].value.as < t_annotated* > ()) {
        yylhs.value.as < t_type* > ()->annotations_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotations_);
        yylhs.value.as < t_type* > ()->annotation_objects_ = std::move(yystack_[0].value.as < t_annotated* > ()->annotation_objects_);
        delete yystack_[0].value.as < t_annotated* > ();
      }
    }
#line 3031 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 131: // SimpleContainerType: MapType
#line 1634 "parse/thrifty.yy"
    {
      driver.debug("SimpleContainerType -> MapType");
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_type* > ();
    }
#line 3040 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 132: // SimpleContainerType: SetType
#line 1639 "parse/thrifty.yy"
    {
      driver.debug("SimpleContainerType -> SetType");
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_type* > ();
    }
#line 3049 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 133: // SimpleContainerType: ListType
#line 1644 "parse/thrifty.yy"
    {
      driver.debug("SimpleContainerType -> ListType");
      yylhs.value.as < t_type* > () = yystack_[0].value.as < t_type* > ();
    }
#line 3058 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 134: // MapType: tok_map "<" FieldType "," FieldType ">"
#line 1651 "parse/thrifty.yy"
    {
      driver.debug("MapType -> tok_map<FieldType, FieldType>");
      yylhs.value.as < t_type* > () = new t_map(yystack_[3].value.as < t_type* > (), yystack_[1].value.as < t_type* > ());
    }
#line 3067 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 135: // SetType: tok_set "<" FieldType ">"
#line 1658 "parse/thrifty.yy"
    {
      driver.debug("SetType -> tok_set<FieldType>");
      yylhs.value.as < t_type* > () = new t_set(yystack_[1].value.as < t_type* > ());
    }
#line 3076 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 136: // ListType: tok_list "<" FieldType ">"
#line 1665 "parse/thrifty.yy"
    {
      driver.debug("ListType -> tok_list<FieldType>");
      yylhs.value.as < t_type* > () = new t_list(yystack_[1].value.as < t_type* > ());
    }
#line 3085 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 137: // $@9: %empty
#line 1672 "parse/thrifty.yy"
    {
      lineno_stack.push(LineType::kAnnotationLastLineno, driver.scanner->get_lineno());
    }
#line 3093 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 138: // TypeAnnotations: "(" TypeAnnotationList CommaOrSemicolonOptional $@9 ")"
#line 1676 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations => ( TypeAnnotationList CommaOrSemicolonOptional)");
      yylhs.value.as < t_annotated* > () = yystack_[3].value.as < t_annotated* > ();
      yylhs.value.as < t_annotated* > ()->annotation_last_lineno_ = lineno_stack.pop(LineType::kAnnotationLastLineno);
    }
#line 3103 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 139: // TypeAnnotations: "(" ")"
#line 1682 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations => ( )");
      yylhs.value.as < t_annotated* > () = nullptr;
    }
#line 3112 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 140: // TypeAnnotations: %empty
#line 1687 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations =>");
      yylhs.value.as < t_annotated* > () = nullptr;
    }
#line 3121 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 141: // TypeAnnotationList: TypeAnnotationList CommaOrSemicolon TypeAnnotation
#line 1694 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotationList => TypeAnnotationList CommaOrSemicolon TypeAnnotation");
      yylhs.value.as < t_annotated* > () = yystack_[2].value.as < t_annotated* > ();
      if (!yystack_[0].value.as < t_annotation* > ()->object_val) {
        yylhs.value.as < t_annotated* > ()->annotations_[yystack_[0].value.as < t_annotation* > ()->key] = yystack_[0].value.as < t_annotation* > ()->val;
      } else {
        yylhs.value.as < t_annotated* > ()->annotation_objects_[yystack_[0].value.as < t_annotation* > ()->key] = yystack_[0].value.as < t_annotation* > ()->object_val;
      }
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 3136 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 142: // TypeAnnotationList: TypeAnnotation
#line 1705 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotationList => TypeAnnotation");
      /* Just use a dummy structure to hold the annotations. */
      yylhs.value.as < t_annotated* > () = new t_annotated();
      if (!yystack_[0].value.as < t_annotation* > ()->object_val) {
        yylhs.value.as < t_annotated* > ()->annotations_[yystack_[0].value.as < t_annotation* > ()->key] = yystack_[0].value.as < t_annotation* > ()->val;
      } else {
        yylhs.value.as < t_annotated* > ()->annotation_objects_[yystack_[0].value.as < t_annotation* > ()->key] = yystack_[0].value.as < t_annotation* > ()->object_val;
      }
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 3152 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 143: // TypeAnnotation: Identifier "=" FieldType ConstMap
#line 1719 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotation TypeAnnotationValueObject");
      yylhs.value.as < t_annotation* > () = new t_annotation;
      yylhs.value.as < t_annotation* > ()->key = yystack_[3].value.as < std::string > ();
      yylhs.value.as < t_annotation* > ()->object_val = std::make_shared<t_const>(
        driver.program,
        yystack_[1].value.as < t_type* > (),
        yystack_[3].value.as < std::string > (),
        std::unique_ptr<t_const_value>(yystack_[0].value.as < t_const_value* > ())
      );
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.validate_const_type(yylhs.value.as < t_annotation* > ()->object_val.get());
      }
    }
#line 3171 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 144: // TypeAnnotation: Identifier TypeAnnotationValue
#line 1734 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotation TypeAnnotationValue");
      yylhs.value.as < t_annotation* > () = new t_annotation;
      yylhs.value.as < t_annotation* > ()->key = yystack_[1].value.as < std::string > ();
      yylhs.value.as < t_annotation* > ()->val = yystack_[0].value.as < std::string > ();
    }
#line 3182 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 145: // TypeAnnotationValue: "=" IntOrLiteral
#line 1743 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotationValue -> = IntOrLiteral");
      yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > ();
    }
#line 3191 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 146: // TypeAnnotationValue: %empty
#line 1748 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotationValue ->");
      yylhs.value.as < std::string > () = "1";
    }
#line 3200 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 147: // StructuredAnnotations: NonEmptyStructuredAnnotationList
#line 1755 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotations => NonEmptyStructuredAnnotationList");
      yylhs.value.as < t_annotated* > () = yystack_[0].value.as < t_annotated* > ();
    }
#line 3209 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 148: // StructuredAnnotations: %empty
#line 1760 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotations =>");
      yylhs.value.as < t_annotated* > () = nullptr;
    }
#line 3218 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 149: // NonEmptyStructuredAnnotationList: NonEmptyStructuredAnnotationList StructuredAnnotation
#line 1767 "parse/thrifty.yy"
    {
      driver.debug("NonEmptyStructuredAnnotationList => NonEmptyStructuredAnnotationList StructuredAnnotation");
      yylhs.value.as < t_annotated* > () = yystack_[1].value.as < t_annotated* > ();
      yylhs.value.as < t_annotated* > ()->structured_annotations_.push_back(yystack_[0].value.as < t_annotation* > ()->object_val);
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 3229 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 150: // NonEmptyStructuredAnnotationList: StructuredAnnotation
#line 1774 "parse/thrifty.yy"
    {
      driver.debug("NonEmptyStructuredAnnotationList =>");
      yylhs.value.as < t_annotated* > () = new t_annotated();
      yylhs.value.as < t_annotated* > ()->structured_annotations_.push_back(yystack_[0].value.as < t_annotation* > ()->object_val);
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 3240 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 151: // StructuredAnnotation: "@" ConstStruct
#line 1783 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotation => @ConstStruct");
      yylhs.value.as < t_annotation* > () = const_struct_to_annotation(
          driver, std::unique_ptr<t_const_value>(yystack_[0].value.as < t_const_value* > ()));
    }
#line 3250 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 152: // StructuredAnnotation: "@" ConstStructType
#line 1789 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotation => @ConstStructType");
      auto value = std::make_unique<t_const_value>();
      value->set_map();
      value->set_ttype(yystack_[0].value.as < t_type* > ());
      yylhs.value.as < t_annotation* > () = const_struct_to_annotation(driver, std::move(value));
    }
#line 3262 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 153: // FunctionAnnotations: TypeAnnotations
#line 1799 "parse/thrifty.yy"
    {
      driver.debug("FunctionAnnotations => TypeAnnotations");
      if (!yystack_[0].value.as < t_annotated* > ()) {
        yylhs.value.as < t_annotated* > () = nullptr;
        break;
      }
      yylhs.value.as < t_annotated* > () = yystack_[0].value.as < t_annotated* > ();
      auto prio_iter = yylhs.value.as < t_annotated* > ()->annotations_.find("priority");
      if (prio_iter == yylhs.value.as < t_annotated* > ()->annotations_.end()) {
        break;
      }
      const std::string& prio = prio_iter->second;
      const std::string prio_list[] = {"HIGH_IMPORTANT", "HIGH", "IMPORTANT",
                                       "NORMAL", "BEST_EFFORT"};
      const auto end = prio_list + sizeof(prio_list)/sizeof(prio_list[0]);
      if (std::find(prio_list, end, prio) == end) {
        std::string s;
        for (const auto& prio : prio_list) {
          s += prio + "','";
        }
        s.erase(s.length() - 3);
        driver.failure("Bad priority '%s'. Choose one of '%s'.",
                       prio.c_str(), s.c_str());
      }
    }
#line 3292 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 154: // IntOrLiteral: tok_literal
#line 1827 "parse/thrifty.yy"
    {
      driver.debug("IntOrLiteral -> tok_literal");
      yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > ();
    }
#line 3301 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 155: // IntOrLiteral: tok_bool_constant
#line 1833 "parse/thrifty.yy"
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> tok_bool_constant");
      sprintf(buf, "%" PRIi64, yystack_[0].value.as < int64_t > ());
      yylhs.value.as < std::string > () = buf;
    }
#line 3312 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;

  case 156: // IntOrLiteral: tok_int_constant
#line 1841 "parse/thrifty.yy"
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> tok_int_constant");
      sprintf(buf, "%" PRIi64, yystack_[0].value.as < int64_t > ());
      yylhs.value.as < std::string > () = buf;
    }
#line 3323 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"
    break;


#line 3327 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        std::string msg = YY_("syntax error");
        error (YY_MOVE (msg));
      }


    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;


      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.what ());
  }

#if YYDEBUG || 0
  const char *
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytname_[yysymbol];
  }
#endif // #if YYDEBUG || 0





  const short parser::yypact_ninf_ = -230;

  const signed char parser::yytable_ninf_ = -75;

  const short
  parser::yypact_[] =
  {
    -230,    11,    16,  -230,   107,    14,    31,    81,    39,    42,
    -230,  -230,   -18,  -230,  -230,  -230,  -230,  -230,  -230,    22,
    -230,  -230,    81,  -230,  -230,  -230,  -230,  -230,  -230,  -230,
    -230,  -230,  -230,    89,    28,  -230,  -230,  -230,  -230,  -230,
      40,    81,  -230,  -230,  -230,  -230,  -230,  -230,  -230,  -230,
    -230,    58,    44,   135,    81,    81,    81,   135,    81,  -230,
      48,     8,  -230,  -230,  -230,  -230,  -230,  -230,  -230,  -230,
    -230,  -230,    54,    59,    61,    50,    81,  -230,    50,  -230,
      50,  -230,  -230,  -230,    74,    47,  -230,    81,    91,   263,
    -230,  -230,    81,    92,  -230,   135,   135,   135,    51,  -230,
      50,  -230,  -230,  -230,    81,    97,    99,    90,  -230,  -230,
    -230,  -230,  -230,   240,   253,   101,  -230,  -230,  -230,  -230,
      40,   100,  -230,     0,   109,    96,   105,  -230,   106,     8,
    -230,  -230,   114,  -230,  -230,  -230,   263,   115,  -230,   125,
       8,  -230,  -230,     8,   263,   135,    28,   132,  -230,   135,
    -230,  -230,   179,  -230,    81,  -230,    50,    28,  -230,  -230,
     133,    50,    50,   263,   263,   136,   263,   137,  -230,   140,
     -12,    50,   134,  -230,  -230,  -230,   142,  -230,  -230,   156,
    -230,   153,     0,    50,    28,  -230,     8,  -230,  -230,   167,
    -230,  -230,  -230,  -230,  -230,  -230,  -230,   198,  -230,  -230,
    -230,  -230,   171,   -17,   176,  -230,    81,  -230,  -230,   263,
    -230,   172,   173,    81,  -230,  -230,  -230,  -230,   181,  -230,
    -230,  -230,   135,    50,   180,    50,  -230,   135,   135,   177,
      37,    81,  -230,  -230,   188,     8,   -15,   187,   150,  -230,
     173,  -230,  -230,   186,  -230,  -230,  -230,   185,   183,   135,
    -230,   200,  -230,   263,    50,  -230,  -230,   184,   150,  -230,
    -230,  -230,     8,   226,  -230,  -230,    50,  -230,  -230,     8,
    -230
  };

  const unsigned char
  parser::yydefact_[] =
  {
      11,     0,    19,     1,     0,     8,     0,     0,     0,     0,
      10,    12,   148,    17,     3,     4,     5,     7,     6,     0,
      15,    16,     0,    77,    18,    21,    24,    25,    20,    26,
      27,    22,    23,     0,   147,   150,    14,    13,    62,   151,
     152,     0,    28,    65,    69,    71,    34,    42,    66,    67,
     149,     0,     0,     0,     0,     0,     0,     0,     0,    61,
       0,    33,    73,   123,   124,   121,   122,   125,   126,   127,
     128,   129,     0,     0,     0,   140,     0,   118,   140,   119,
     140,   131,   132,   133,     0,    76,    35,     0,     0,     0,
      30,    31,    32,     0,    80,     0,     0,     0,     0,   117,
     140,   120,   130,    95,     0,     0,     0,     0,    95,    47,
      44,    45,    46,     0,     0,    48,    64,    49,    50,    51,
       0,     0,    60,     8,     0,     0,     0,   139,   146,    33,
     142,    29,     8,    75,    73,    38,     0,     8,    57,     0,
      33,    53,    55,    33,     0,     0,   148,     0,    79,     0,
     136,   135,     0,   144,    32,   137,   140,   148,    94,    80,
       8,   140,   140,     0,    32,     0,    32,     0,    63,     0,
      90,   140,     0,   154,   155,   156,     0,   145,   141,     0,
      70,    98,     8,   140,   148,    37,    33,    68,    59,     0,
      56,    54,    52,    82,    87,    88,    89,     0,    78,   134,
     143,   138,     0,   101,     0,    36,     0,    32,    43,     0,
     107,     0,     4,     0,   104,   109,   105,   113,   106,    97,
      99,   100,     0,   140,    41,   140,    58,     0,     0,     0,
       0,     0,   153,    72,     0,    33,     0,     0,   115,    85,
       0,   108,   112,   103,    40,    39,   110,     0,     0,     0,
     116,     8,    84,     0,   140,    95,   111,     0,    93,    83,
      86,   102,    33,     8,   114,    92,   140,    96,    91,    33,
      81
  };

  const short
  parser::yypgoto_[] =
  {
    -230,  -230,    -7,    -2,  -230,  -230,  -230,  -230,  -230,  -230,
    -230,  -230,  -230,   -53,  -119,  -230,  -230,  -230,  -230,  -230,
    -230,  -230,  -230,   -91,  -230,  -230,    75,  -230,   228,   232,
    -230,  -230,  -230,  -230,  -230,  -230,  -230,  -230,   124,    77,
    -230,  -230,  -230,   104,  -230,  -230,  -230,  -230,  -230,  -229,
    -230,  -107,    13,  -230,  -230,  -230,  -230,  -230,    43,  -230,
      46,    25,   -37,  -230,  -230,  -230,  -230,  -230,  -230,  -230,
     -73,  -230,  -230,   123,  -230,  -129,  -230,   245,    19,  -230
  };

  const short
  parser::yydefgoto_[] =
  {
      -1,     1,    75,   157,     4,     2,    10,    11,     5,    24,
      25,    26,    53,   207,    93,    27,    56,   106,   160,   185,
     225,    28,    57,   116,   117,   143,   118,   140,   119,   120,
      61,    49,    29,    58,    30,    54,    31,    55,    94,   147,
     105,    32,    41,   123,   148,   251,   252,   259,   197,   248,
     266,   132,   158,   203,   222,   254,   213,   214,   215,   216,
     217,   237,   238,    77,    78,    79,    80,    81,    82,    83,
     232,   179,   129,   130,   153,    33,    34,    35,   233,   177
  };

  const short
  parser::yytable_[] =
  {
      19,   137,    99,    12,    22,   101,   246,   102,    92,   250,
     155,     3,    37,   -74,    -2,    38,    76,   170,    90,    91,
      87,   165,   139,   142,   167,    14,    36,   131,   181,   265,
     194,   195,   196,   247,    52,    13,   220,   221,    23,    -9,
      -9,    -9,    -9,    20,    60,   161,    21,    84,    85,    86,
      22,    88,    51,   168,    14,   206,    62,   145,   124,   125,
     126,    14,    89,    15,    16,    17,    18,   208,    98,   100,
     127,    59,   188,   189,    95,   191,   154,   211,   240,    96,
     107,    97,   115,   180,    14,   121,   103,   164,   186,   187,
     166,   128,    15,    16,    17,    18,   104,   133,   198,    15,
      16,    17,    18,   108,   136,   122,   115,   115,   169,   134,
     205,   135,   172,   -62,   144,   176,   245,   150,   226,   149,
     152,   146,    15,    16,    17,    18,   151,   156,   162,   115,
       6,     7,     8,     9,    42,    43,    44,   115,    14,    45,
      46,    47,   163,   267,    48,   171,   183,   128,   263,   190,
     270,   193,   235,   192,   113,   199,   115,   115,   184,   115,
     218,   202,   261,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,   201,    15,    16,    17,    18,
     146,   262,    14,   173,   209,   231,   174,   175,   219,   223,
     236,   230,   227,   228,   234,   239,   244,   249,   247,   224,
     253,    14,   115,   255,   256,   264,   229,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,   258,
      15,    16,    17,    18,   243,   210,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,   211,   212,
      16,    17,    18,    14,   109,   268,   115,   110,   111,   112,
      39,   200,   113,   138,    40,   114,    14,   109,   159,   204,
     110,   111,   112,   182,   260,   113,    14,   109,   114,   141,
     110,   111,   112,   241,   257,   113,   242,   178,   114,    50,
       0,    15,    16,    17,    18,   269,     0,     0,     0,     0,
       0,     0,     0,     0,    15,    16,    17,    18,     0,     0,
       0,     0,     0,     0,    15,    16,    17,    18
  };

  const short
  parser::yycheck_[] =
  {
       7,   108,    75,     5,    22,    78,    21,    80,    61,   238,
     129,     0,    19,    13,     0,    22,    53,   146,    10,    11,
      57,   140,   113,   114,   143,     3,     4,   100,   157,   258,
      42,    43,    44,    48,    41,     4,    53,    54,    56,    23,
      24,    25,    26,     4,    51,   136,     4,    54,    55,    56,
      22,    58,    12,   144,     3,   184,    12,    57,    95,    96,
      97,     3,    14,    41,    42,    43,    44,   186,    18,    76,
      19,    13,   163,   164,    20,   166,   129,    40,    41,    20,
      87,    20,    89,   156,     3,    92,    12,   140,   161,   162,
     143,    98,    41,    42,    43,    44,    49,   104,   171,    41,
      42,    43,    44,    12,    14,    13,   113,   114,   145,    12,
     183,    12,   149,    12,    14,   152,   235,    21,   209,    10,
      14,   123,    41,    42,    43,    44,    21,    13,    13,   136,
      23,    24,    25,    26,    45,    46,    47,   144,     3,    50,
      51,    52,    17,   262,    55,    13,    13,   154,   255,    13,
     269,    11,   225,    16,    12,    21,   163,   164,   160,   166,
     197,     8,   253,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    19,    41,    42,    43,    44,
     182,   254,     3,     4,    17,   222,     7,     8,    17,    13,
     227,    10,    20,    20,    14,    18,     8,    10,    48,   206,
      14,     3,   209,    18,    21,    21,   213,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    19,
      41,    42,    43,    44,   231,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,     3,     4,    19,   253,     7,     8,     9,
      22,   176,    12,    13,    22,    15,     3,     4,   134,   182,
       7,     8,     9,   159,   251,    12,     3,     4,    15,    16,
       7,     8,     9,   230,   249,    12,   230,   154,    15,    34,
      -1,    41,    42,    43,    44,   266,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    42,    43,    44
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,    59,    63,     0,    62,    66,    23,    24,    25,    26,
      64,    65,    61,     4,     3,    41,    42,    43,    44,    60,
       4,     4,    22,    56,    67,    68,    69,    73,    79,    90,
      92,    94,    99,   133,   134,   135,     4,    60,    60,    86,
      87,   100,    45,    46,    47,    50,    51,    52,    55,    89,
     135,    12,    60,    70,    93,    95,    74,    80,    91,    13,
      60,    88,    12,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    60,   120,   121,   122,   123,
     124,   125,   126,   127,    60,    60,    60,   120,    60,    14,
      10,    11,    71,    72,    96,    20,    20,    20,    18,   128,
      60,   128,   128,    12,    49,    98,    75,    60,    12,     4,
       7,     8,     9,    12,    15,    60,    81,    82,    84,    86,
      87,    60,    13,   101,   120,   120,   120,    19,    60,   130,
     131,   128,   109,    60,    12,    12,    14,   109,    13,    81,
      85,    16,    81,    83,    14,    57,    61,    97,   102,    10,
      21,    21,    14,   132,    71,    72,    13,    61,   110,    96,
      76,    81,    13,    17,    71,    72,    71,    72,    81,   120,
     133,    13,   120,     4,     7,     8,   120,   137,   131,   129,
     128,   133,   101,    13,    61,    77,   128,   128,    81,    81,
      13,    81,    16,    11,    42,    43,    44,   106,   128,    21,
      84,    19,     8,   111,    97,   128,   133,    71,    72,    17,
      27,    40,    41,   114,   115,   116,   117,   118,   120,    17,
      53,    54,   112,    13,    60,    78,    81,    20,    20,    60,
      10,   120,   128,   136,    14,   128,   120,   119,   120,    18,
      41,   116,   118,    60,     8,    72,    21,    48,   107,    10,
     107,   103,   104,    14,   113,    18,    21,   119,    19,   105,
     110,    81,   128,   109,    21,   107,   108,    72,    19,   136,
      72
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,    58,    59,    60,    60,    60,    60,    60,    61,    62,
      63,    63,    64,    64,    64,    64,    64,    65,    66,    66,
      67,    67,    67,    67,    68,    68,    68,    68,    70,    69,
      71,    71,    72,    72,    74,    75,    73,    76,    76,    77,
      78,    78,    80,    79,    81,    81,    81,    81,    81,    81,
      81,    81,    82,    82,    83,    83,    84,    84,    85,    85,
      86,    86,    87,    88,    88,    89,    89,    91,    90,    93,
      92,    95,    94,    96,    97,    98,    98,   100,    99,   101,
     101,   102,   102,   103,   103,   104,   105,   106,   106,   106,
     106,   107,   108,   108,   109,   109,   110,   111,   111,   112,
     112,   112,   113,   113,   114,   114,   114,   114,   115,   115,
     116,   116,   117,   117,   118,   119,   119,   120,   120,   120,
     121,   122,   122,   122,   122,   122,   122,   122,   122,   122,
     123,   124,   124,   124,   125,   126,   127,   129,   128,   128,
     128,   130,   130,   131,   131,   132,   132,   133,   133,   134,
     134,   135,   135,   136,   137,   137,   137
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     2,     1,     1,     1,     1,     1,     0,     0,
       3,     0,     1,     3,     3,     2,     2,     2,     3,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     6,
       1,     1,     1,     0,     0,     0,     9,     2,     0,     5,
       3,     1,     0,     9,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     2,     3,     1,     4,     2,     5,     3,
       5,     3,     1,     5,     3,     1,     1,     0,     8,     0,
       8,     0,    11,     0,     0,     2,     0,     0,     9,     2,
       0,    11,     3,     2,     1,     0,     1,     1,     1,     1,
       0,     4,     1,     0,     2,     0,     9,     2,     0,     1,
       1,     0,     2,     0,     1,     1,     1,     1,     3,     1,
       4,     5,     3,     1,     6,     1,     2,     2,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     6,     4,     4,     0,     5,     2,
       0,     3,     1,     4,     2,     2,     0,     1,     0,     2,
       1,     2,     2,     1,     1,     1,     1
  };


#if YYDEBUG
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "tok_eof", "error", "\"invalid token\"", "tok_identifier",
  "tok_literal", "tok_doctext", "tok_st_identifier", "tok_bool_constant",
  "tok_int_constant", "tok_dub_constant", "\",\"", "\";\"", "\"{\"",
  "\"}\"", "\"=\"", "\"[\"", "\"]\"", "\":\"", "\"(\"", "\")\"", "\"<\"",
  "\">\"", "\"@\"", "tok_include", "tok_namespace", "tok_cpp_include",
  "tok_hs_include", "tok_void", "tok_bool", "tok_byte", "tok_string",
  "tok_binary", "tok_i16", "tok_i32", "tok_i64", "tok_double", "tok_float",
  "tok_map", "tok_list", "tok_set", "tok_stream", "tok_sink", "tok_oneway",
  "tok_idempotent", "tok_readonly", "tok_typedef", "tok_struct",
  "tok_xception", "tok_throws", "tok_extends", "tok_service", "tok_enum",
  "tok_const", "tok_required", "tok_optional", "tok_union",
  "tok_interaction", "tok_performs", "$accept", "Program", "Identifier",
  "CaptureDocText", "DestroyDocText", "HeaderList", "Header", "Include",
  "DefinitionList", "Definition", "TypeDefinition", "Typedef", "$@1",
  "CommaOrSemicolon", "CommaOrSemicolonOptional", "Enum", "$@2", "$@3",
  "EnumDefList", "EnumDef", "EnumValue", "Const", "$@4", "ConstValue",
  "ConstList", "ConstListContents", "ConstMap", "ConstMapContents",
  "ConstStruct", "ConstStructType", "ConstStructContents", "StructHead",
  "Struct", "$@5", "Xception", "$@6", "Service", "$@7", "FlagArgs",
  "UnflagArgs", "Extends", "Interaction", "$@8", "FunctionList",
  "Function", "ParamList", "EmptyParamList", "Param", "FunctionQualifier",
  "Throws", "MaybeThrows", "FieldList", "Field", "FieldIdentifier",
  "FieldRequiredness", "FieldValue", "FunctionType",
  "ResponseAndStreamReturnType", "StreamReturnType",
  "ResponseAndSinkReturnType", "SinkReturnType", "SinkFieldType",
  "FieldType", "BaseType", "SimpleBaseType", "ContainerType",
  "SimpleContainerType", "MapType", "SetType", "ListType",
  "TypeAnnotations", "$@9", "TypeAnnotationList", "TypeAnnotation",
  "TypeAnnotationValue", "StructuredAnnotations",
  "NonEmptyStructuredAnnotationList", "StructuredAnnotation",
  "FunctionAnnotations", "IntOrLiteral", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   344,   344,   357,   361,   365,   369,   373,   379,   390,
     399,   404,   409,   413,   420,   427,   434,   441,   461,   469,
     474,   484,   492,   503,   516,   526,   536,   546,   559,   558,
     581,   583,   587,   592,   598,   602,   597,   625,   653,   660,
     680,   699,   714,   713,   743,   749,   760,   766,   771,   799,
     804,   809,   816,   821,   829,   835,   844,   850,   858,   864,
     873,   882,   894,   914,   920,   929,   933,   940,   939,   966,
     965,  1022,  1021,  1046,  1051,  1056,  1071,  1077,  1076,  1118,
    1125,  1131,  1174,  1187,  1196,  1202,  1210,  1217,  1221,  1226,
    1232,  1238,  1244,  1248,  1253,  1263,  1269,  1312,  1349,  1356,
    1367,  1379,  1384,  1394,  1399,  1404,  1409,  1414,  1421,  1427,
    1434,  1446,  1460,  1466,  1473,  1484,  1488,  1494,  1540,  1545,
    1556,  1575,  1580,  1585,  1590,  1595,  1600,  1605,  1610,  1615,
    1621,  1633,  1638,  1643,  1650,  1657,  1664,  1672,  1671,  1681,
    1687,  1693,  1704,  1718,  1733,  1742,  1748,  1754,  1760,  1766,
    1773,  1782,  1788,  1798,  1826,  1832,  1840
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 159 "parse/thrifty.yy"
} } } } // apache::thrift::compiler::yy
#line 3849 "/builddir/build/BUILD/fbthrift-2021.02.01.00/armv7hl-redhat-linux-gnueabi/thrift/compiler/thrifty.cc"

#line 1848 "parse/thrifty.yy"


/**
 * Method that will be called by the generated parser upon errors.
 */
void apache::thrift::compiler::yy::parser::error(std::string const& message) {
  driver.yyerror("%s", message.c_str());
}
